<?php

namespace App\Http\Requests\Admin;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class PageRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        if (! Auth::check()) {
            return false;
        }
        if(in_array(Auth::user()->role, ['super_admin', 'admin', 'sub_admin']))
        {
            return true;
        }

        if(Auth::user()->hasModule( 'pages' ) )
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules=[];

        $images = [1,2,4,7,8,9,11,12,13,14,16,17,18,19,20];
        $second_images = [1,2,4,8,9,11,12,13,14];
        if(in_array($this->page->id,$images))
        {
            $rules['image'] = 'required';
        }
        if(in_array($this->page->id,$second_images))
        {
            $rules['second_image'] = 'required';
        }
        foreach (languages() as $lang) {
            $lang_rules=[
                'title_'.$lang->local=> 'required|min:3',
//                'slug_'.$lang->local=> [
//                    "required",
//                    Rule::unique('page_descriptions', 'slug')->ignore($this->page? $this->page->id : 0, 'page_id')
//                ],
//                'keywords_'.$lang->local=> 'required|min:3',
//                'meta_description_'.$lang->local=> 'required|min:3',


            ];

            $rules= array_merge($rules, $lang_rules);
            if(!in_array($this->page->id,[12,14]))
            {
                $rules['description_'.$lang->local]= 'required';
            }
        }

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $field = metaFields('pages');
        $attributes=[
            'image'=>__('pages.image'),
            'second_image'=>__('pages.second_image')
        ];
        foreach (languages() as $lang) {
            $lang_attributes=[
                'title_'.$lang->local=> $field[$lang->local]['title'] ?? __('pages.title'),
                'slug_'.$lang->local=>  $field[$lang->local]['slug'] ?? __('pages.slug'),
                'keywords_'.$lang->local=> $field[$lang->local]['keywords'] ?? __('pages.keywords'),
                'meta_description_'.$lang->local=> $field[$lang->local]['meta_description'] ?? __('pages.meta_description'),
                'description_'.$lang->local=> $field[$lang->local]['description'] ?? __('pages.description'),
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }
        return $attributes;
    }
    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
